
/*
 * it is assumed that expr only needs to be processed as a regular
 * string, and not a [fancy] regular expression
 */
void
context_grep(int argc, char **argv, int context, char *expr)
{
	int line;
	int clean_hit;
	int c_before;
	int c_after;
	int cursor;

	/*
	 * check for limits quick exit
	 */
	/* if there are no strings to search, just return immediately */
	if (argc <= 0) {
		return;
	}
	/* avoid segfault if argv is NULL */
	if (argv == NULL) {
		return;
	}
	/* if the expression is null, assume it matches nothing */
	if ((expr == NULL) || (expr[0] == '\0')) {
		return;
	}
	/* if context is negative, that's an error */
	if (context < 0) {
		/* printf("%s\n", usage); */
		return;
	}


	line = cursor = 0;

	while (line < argc) {
//printf("->string is '%s' expr is '%s'\n", argv[line], expr);fflush(stdout);
		if (argv[line] == NULL) {
			break;
		}
		if (strstr(argv[line], expr)) {
			for (c_before = 0; c_before < context; c_before++) {
				if ((line - (context - c_before)) < 0) {
					continue;
				}
				if ((line - (context - c_before)) <= cursor) {
					continue;
				}
				printf("%s\n", argv[line - (context - c_before)]);
				cursor = line - (context - c_before);
			}
			printf("%s\n", argv[line]);
			cursor = line;
			fflush(stdout);
			c_after = 1;
			while (c_after <= context) {
				line = line + 1;
				if (line >= argc) {
					return;
				}
				/* try to avoid those segv */
				if (argv[line] == NULL) {
					return;
				}
				printf("%s\n", argv[line]);
				cursor = line;
				if (strstr(argv[line], expr)) {
					c_after = 1;
					continue;
				}
				c_after = c_after + 1;
			}
		}

		line = line + 1;
	}
}
