#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "context_grep.c"


/*
 * used for testing
 */
 void
main(int argc, char **argv)
{
	int n;
	int i;
	int ctx;
	char expression[64];
	char *input;
	struct istrings {
		struct istrings *next;
		char *str;
	} *head, *new;
	char **str_args;

	n = scanf("%d\n", &ctx);
	if (n != 1) {
		fprintf(stderr, "Error, something when wrong reading context\n");
		exit(1);
	}

	n = scanf("%62s\n", expression);
	if (n != 1) {
		fprintf(stderr, "Error, something when wrong reading expression\n");
		exit(1);
	}

	new = (struct istrings *)&head;

	n = 0;
	/* read lines up to 128 chars, skip leading white space */
	while(scanf(" %128m[^\n]", &input)) {
		if (input == NULL) {
			break;
		}
		n++;
		if (n > 20480) {
			printf("More than 20K input strings?  That's too many.\n");
			exit(1);
		}
		new->next = (struct istrings *)calloc(1, sizeof(struct istrings));
		new = (struct istrings *)new->next;
		new->str = input;
	}

	new = head;
	str_args = (char **)calloc(n + 1, sizeof(char *)); /* last elem is NULL */
	for (i = 0; i < n; i++) {
		str_args[i] = new->str;
		new = new->next;
	}

//printf("calling context_grep\n");fflush(stdout);

	context_grep(n, str_args, ctx, expression);

//printf("back from context_grep\n");fflush(stdout);

}

